package config

import (
    "Crazy_Push/configs"
)

const(
    SUCCESS                               = 0 //成功
    REQUEST_PARAM_ERROR                   = -1               // 请求参数错误
    SYSTEM_ERROR                          = -1000            // 系统异常
    UNAUTHORIZED_REQUEST                  = -1001            // 未经授权的请求,Token错误
    API_TIME_EXPIRED                      = -1002            // Token过期
    API_FREQUENT_REQUESTS                 = -1003            // 接口频繁请求
    DIAMOND_NOT_ENOUGH                    = -1005           // 钻石不足
    MONEY_NOT_RNOUGH                      = -1006            //金币不足
    LEVEL_NOT_RNOUGH                      = -1007            //等级不足
    LIMIT_NOT_RNOUGH                      = -1008            //次数不足
    PROP_NOT_RNOUGH                       = -1009            //道具不足
    CONDITION_NOT_RNOUGH                  = -1010            //条件不足
    RATE_NOT_RNOUGH                       = -1011            //进度不足

    USER_NOT_EXISTS                       = -1020            //玩家信息不存在
    NOT_MY_FRIEND                         = -1030            //不是我的好友
    NOT_FOUND_ACTIVITY                    = -1031            //活动不存在
    NOT_FOUND_GOODINFO                    = -1032            //商品信息不存在

    NOT_OPEN                              = -2001           //暂未开放
    REPET_REWRD                           = -2002            //重复领奖

    RESURRECTION_CONFIG_ERROR             = -10001        // 矿工游戏复活配置异常
    TODAY_NO_PLAY_MINING_GAME             = -10002        // 矿工游戏当天未进行游戏
    MINING_GAME_STAGE_REWARDED            = -10003        // 矿工游戏阶段奖励已领取过
    MINING_GAME_STAGE_REWARD_CONFIG_ERROR = -10004        // 矿工游戏阶段奖励配置异常

    LUCKYDRAWBYDIAMOND_CONFIG_ERROR       = -10005        // 钻石夺宝配置异常
    SHARELINK_TIME_EXPIRED                = -10006        // 奖励链接过期
    SHARELINK_USER_LIMIT                  = -10007        // 奖励链接，不在指定用户里
    EXCHANGCODE_USER_LIMIT                = -10008        // 兑换码，不在指定用户里
    GIFT_EMPTY_ERROR                      = -10009        // 礼包空
    GIFT_UID_ERROR                        = -10010        // 礼包用户异常
    GIFT_REWARD_ERROR                     = -10011        // 礼包领取异常
    SYNCIOSSUBSCRIBE_TRANSACTIONID_ERROR  = -10012        // 订阅同步-交易号ID异常
    SYNCIOSSUBSCRIBE_ORDER_ERROR          = -10013        // 订阅同步-交易单异常
    SYNCIOSSUBSCRIBE_UID_ERROR            = -10014        // 订阅同步-用户ID异常
    STEELSAFE_REWARDED                    = -10015        // 保险柜-已经领取过奖励
    STEELSAFE_PROGRESS_ERROR              = -10016        // 保险柜-未达进度标准

    //召回好友
    CALLBACK_FRIEND_LEVEL_LOW             = -10320        // 低等级好友不支持召回
    CALLBACK_FRIEND_DAYS_LIMIT            = -10321        // 超过15天未登录的玩家才能被召回
    CALLBACK_FRIEND_DAY_ALREADY           = -10322        // 该好友当天已经召回过了
    CALLBACK_FRIEND_ONLY_FB               = -10323        // 召回只支持fb玩家
)

var ErrList = map[int]string {
    SUCCESS:                               "成功",
    REQUEST_PARAM_ERROR:                   "请求参数错误",
    SYSTEM_ERROR:                          "系统异常",
    UNAUTHORIZED_REQUEST:                  "未经授权的请求,Token错误",
    API_TIME_EXPIRED:                      "Token过期",
    API_FREQUENT_REQUESTS:                 "接口频繁请求",
    DIAMOND_NOT_ENOUGH:                    "钻石不足",
    MONEY_NOT_RNOUGH:                      "金币不足",
    LEVEL_NOT_RNOUGH:                      "等级不足",
    LIMIT_NOT_RNOUGH:                      "次数不足",
    PROP_NOT_RNOUGH:                       "道具不足",
    CONDITION_NOT_RNOUGH:                  "条件不足",
    RATE_NOT_RNOUGH:                       "进度不足",

    USER_NOT_EXISTS:                       "玩家信息不存在",
    NOT_MY_FRIEND:                         "不是我的好友",
    NOT_FOUND_ACTIVITY:                    "活动不存在",
    NOT_FOUND_GOODINFO:                    "商品信息不存在",

    NOT_OPEN:                              "暂未开放",
    REPET_REWRD:                           "重复领奖",

    RESURRECTION_CONFIG_ERROR:             "矿工游戏复活配置异常",
    TODAY_NO_PLAY_MINING_GAME:             "矿工游戏当天未进行游戏",
    MINING_GAME_STAGE_REWARDED:            "矿工游戏阶段奖励已领取过",
    MINING_GAME_STAGE_REWARD_CONFIG_ERROR: "矿工游戏阶段奖励配置异常",

    LUCKYDRAWBYDIAMOND_CONFIG_ERROR:       "钻石夺宝配置异常",
    SHARELINK_TIME_EXPIRED:                "奖励链接过期",
    SHARELINK_USER_LIMIT:                  "奖励链接不在指定用户里",
    EXCHANGCODE_USER_LIMIT:                "兑换码不在指定用户里",
    GIFT_EMPTY_ERROR:                      "礼包空",
    GIFT_UID_ERROR:                        "礼包用户异常",
    GIFT_REWARD_ERROR:                     "礼包领取异常",
    SYNCIOSSUBSCRIBE_TRANSACTIONID_ERROR:  "订阅同步-交易号ID异常",
    SYNCIOSSUBSCRIBE_ORDER_ERROR:          "订阅同步-交易单异常",
    SYNCIOSSUBSCRIBE_UID_ERROR:            "订阅同步-用户ID异常",
    STEELSAFE_REWARDED:                    "保险柜-已经领取过奖励",
    STEELSAFE_PROGRESS_ERROR:              "保险柜-未达进度标准",
    //召回好友
    CALLBACK_FRIEND_LEVEL_LOW:             "低等级好友不支持召回",
    CALLBACK_FRIEND_DAYS_LIMIT:            "超过15天未登录的玩家才能被召回",
    CALLBACK_FRIEND_DAY_ALREADY:           "该好友当天已经召回过了",
    CALLBACK_FRIEND_ONLY_FB:               "召回只支持fb玩家",
}

//获取错误信息
func GetErrMsg(errId int) string {
    if ErrList[errId] == "" {
        return "未知消息"
    }
    return ErrList[errId]
}

//获取系统服务配置
func GetServerConf() map[string]string {
    return sysConfig.GetServerConf()
}
