package controllers

import (
    "strings"
    "net/http"

	"Crazy_Push/configs"
	"Crazy_Push/core/function"
	"Crazy_Push/models/games"
	"Crazy_Push/models/utils"
	"Crazy_Push/models/okeys"
	"Crazy_Push/models/dblogic"

    "github.com/gin-gonic/gin"
)

//拉起crazy_fox配置数据
func CrazyConfig(c *gin.Context) {
    params := map[string][]string {
        "version": []string{"string"},
        "sid": []string{"int64"},
    }
    ret, _ := getQryParam(params, c)

    var version string
    if ret["version"] == nil || ret["version"].(string) == "" {
        version = "1.0.0.0"
    } else {
        version = ret["version"].(string)
    }

    var sid int64
    if ret["sid"] == nil || ret["sid"].(int64) == 0 {
        sid = 1
    } else {
        sid = ret["sid"].(int64)
    }

    res := gin.H{}

    readConf := games.NewReadConfig()
    configPath := readConf.GetStaticConfigPath(sid)
    res["Lang"] = readConf.GetLangStaticConfigPath()
    md5Confs := readConf.GetStaticMd5ConfigPath()
    for k, v := range md5Confs {
        res[function.Ucfirst(k)+"Md5"] = v
    }

    dblogic.R("Games").Incr(okeys.GetVersionCount()) //登陆成功率统计

    version = utils.ChangeVersionLength(version, 3)
    rVersion, _ := dblogic.R("Games").Get(okeys.CurForeVersion(sid))
    if !games.CompareVersion(version, rVersion) {
        configPath["Version"] = strings.Replace(configPath["Version"], "Version", "VersionForce", -1)
    }

    if !games.CompareVersion(version, "1.7.4") {
        configPath["VipConfig"] = "VipConfig1599446560.json"
    } else if !games.CompareVersion(version, "1.8.5") {
        //1.8.5版本vip功能修改
        configPath["VipConfig"] = "VipConfig1612259276.json"
    }

    if !games.CompareVersion(version, "1.7.3") {
        configPath["LuckyDraw"] = "LuckyDraw1585289352.json"
    }

    for k, v := range configPath {
        res[k] = v
    }

    //签到进度 版本区分
    if !games.CompareVersion(version, "1.7.0") {
        res["Signin"] = "Signin1600949611.json"
    }

    //分享配置 版本区分
    if !games.CompareVersion(version, "1.7.4") {
        res["Share"] = "ShareConfig1584067106.json"
        res["LDE"] = "LDE.json"
        res["LEN"] = "LEN.json"
        res["LES"] = "LES.json"
        res["LFR"] = "LFR.json"
        res["LID"] = "LID.json"
        res["LNO"] = "LNO.json"
        res["LPT"] = "LPT.json"
        res["LTH"] = "LTH.json"
        res["LTW"] = "LTW.json"
        res["LVI"] = "LVI.json"
        res["LZH"] = "LZH.json"
    }

    if !games.CompareVersion(version, "1.7.3") {
        res["MiningGameConfig"] = "MiningGameConfig1598514140.json"
    }
    if !games.CompareVersion(version, "1.7.8") {
        if sysConfig.IsDebugMode() {
            res["RemoteAssets"] = "RemoteAssets_1770.json"
            res["MainBgConfig"] = "MainBgConfig1598320209.json"
        } else {
            res["RemoteAssets"] = "RemoteAssets_1770.json"
            res["MainBgConfig"] = "MainBgConfig1601470837.json"
        }
    } else {
        if !games.CompareVersion(version, "1.8.3") {
            if sysConfig.IsDebugMode() {
                res["RemoteAssets"] = "RemoteAssets1615770897.json"
            } else {
                res["RemoteAssets"] = "RemoteAssets1615607975.json"
            }
        }
    }

    if !games.CompareVersion(version, "1.8.4") {
        if sysConfig.IsDebugMode() {
            res["RecommendConfig"] = "RecommendConfig1615557861.json"
        }else{
            res["RecommendConfig"] = "RecommendConfig1614071352.json"
        }
    }
    res["hotupdate"] = readConf.GetGameUpdateHotfix(sid, version)
    c.JSON(http.StatusOK, res)
}
