package controllers

import (
    "net/http"
    //"fmt"

	"Crazy_Push/cmd/http/conf"
	"Crazy_Push/models/games"

    "github.com/gin-gonic/gin"
)

var (
    gactivity = NewActivity()
    gcard = NewCard()
    //各api接口附加参数配置
    apiExtraParams = map[string]map[string][]string {
        "Activity.joinRankRoom" : map[string][]string {
            "aid": []string{"uint64", getStringCode(config.REQUEST_PARAM_ERROR)},
        },
    }
)

//api请求列表
var apis = map[string]func(map[string]interface{}, *gin.Context) {
    "Activity.joinRankRoom":   gactivity.JoinRankRoom, //加入排行榜活动房间
    //"Activity.getCurRankData": gactivity.GetCurRankData, //当前排行榜数据
    "Card.Info": gcard.Info, //获得卡片信息-1.3.7 改版
}

func GateWay(c *gin.Context) {
    param, ok := c.GetPostForm("param")
    //客户端请求必传参数
    params := map[string][]string {
        "sid": []string{"uint64", getStringCode(config.REQUEST_PARAM_ERROR)},
        "lid": []string{"uint64", getStringCode(config.REQUEST_PARAM_ERROR)},
        "uid": []string{"uint64", getStringCode(config.REQUEST_PARAM_ERROR)},
        "mod": []string{"string", getStringCode(config.REQUEST_PARAM_ERROR)},
        "act": []string{"string", getStringCode(config.REQUEST_PARAM_ERROR)},
    }

    var ret map[string]interface{}
    var errId int
    if !ok {
        ret, errId = getParams(params, c) //非加密方式传输
    } else {
        //解码请求参数map[string]string
        ret, errId = getDecodeParams(params, games.GetReqParams(param))
    }
    if errId != 0 {
        c.JSON(http.StatusOK, getErrJson(errId))
        return
    }
    api := ret["mod"].(string)+"."+ret["act"].(string)

    if _, ok := apis[api]; !ok {
        c.JSON(http.StatusOK, getErrJson(config.REQUEST_PARAM_ERROR))
        return
    }

    //非加密方式传输,将额外的参数塞入map ret中
    if _, ok2 := apiExtraParams[api]; !ok && ok2 {
        ret2, errId2 := getParams(apiExtraParams[api], c) //非加密方式传输
        if errId2 != 0 {
            c.JSON(http.StatusOK, getErrJson(errId2))
            return
        }
        for k, v := range ret2 {
            ret[k] = v
        }
    }

    reqWithParams(api, ret, c)
    return
}

//api请求参数
func reqWithParams(api string, params map[string]interface{}, c *gin.Context) {
    apis[api](params, c)
}
