package controllers

import (
    "fmt"
	"Crazy_Push/models/games"
	//"encoding/json"
    "strconv"

	"github.com/gorilla/websocket"

	//"github.com/astaxie/beego"
    "github.com/gin-gonic/gin"
)

//websocket
func Join(c *gin.Context) {
	//uid, err  := this.GetInt64("uid", 0)
    uid, err   := strconv.ParseInt(c.Param("uid"), 0, 64)
	token      := c.Param("token")
    msg, code  := "", 0
    if err != nil || uid <= 0 || token == "" {
        msg  = "请求参数错误"
        code = -1
    }
    if !games.VerifyToken(uid, token) {
        msg  = "授权失败"
        code = -1002
    }else{
        code = 1
    }

    games.CheckOldUser(uid) //重复登录验证

	ws, err := websocket.Upgrade(c.Writer, c.Request, nil, 1024, 1024)
	if _, ok := err.(websocket.HandshakeError); ok {
        fmt.Println(">>>>>>>>>>>>>>>Not a websocket handshake", uid)
		return
	}
    if err != nil {
        fmt.Println(">>>>>>>>>>>>>>>", uid)
		return
	}

    msg = games.RspMsg("userBind", code, msg, "")
    if code < 1 {
        ws.WriteMessage(websocket.TextMessage, []byte(msg))
        ws.Close()
        return
    }

    games.InitWebSocket(uid, ws)
}
