package main

import (
	sysConfig "Crazy_Push/configs"
	"flag"
	"fmt"
	"runtime"
	"time"

	"Crazy_Push/models/ab"
	"Crazy_Push/models/utils"
	"Crazy_Push/models/utils/log"
)

var (
	env = flag.String("e", "dev", "push推送 report url,value must be in [env,prod]")
)

func main() {
	runtime.GOMAXPROCS(1) //只跑单核
	flag.Parse()
	if *env != "dev" && *env != "prod" {
		fmt.Println("环境参数设置错误,可设置参数为:[dev,prod]")
		return
	}
	sysConfig.ENV = *env
	utils.InitGoroutinePool()

	//Todo:优化
	logUrl := "http://172.22.107.136:8088"
	log.InitLogger(logUrl, "systemlog", "PushService", "", true)
	firebase := ab.NewFirebase()
	go firebase.HttpDispatch() //调度
	for {
		data, _ := firebase.PopDataFromRedis()
		if data == "" {
			time.Sleep(3 * time.Second) //没有数据了,休息30秒
			continue
		}
		go firebase.NewPushEvent(data) //推送给crazyspin
		time.Sleep(3 * time.Millisecond)
	}
}
