package main

import (
	sysConfig "Crazy_Push/configs"
	"flag"
	"fmt"
	"runtime"
	"time"

	"Crazy_Push/core/exp"
	"Crazy_Push/models/log"
	"Crazy_Push/models/statistics"
)

var (
	env = flag.String("e", "dev", "用户流水 report url,value must be in [env,prod]")
)

func main() {
	runtime.GOMAXPROCS(2) //只跑2核
	flag.Parse()
	if *env != "dev" && *env != "prod" {
		fmt.Println("环境参数设置错误,可设置参数为:[dev,prod]")
		return
	}
	sysConfig.ENV = *env
	exp.Try(func() {
		go statistics.NewAssetsLogs().AsyncAssetLogs()          //流水日志落地
		go statistics.NewAssetsLogs().AsyncAssetAfterHourLogs() //前一个小时流水日志落地
		//go statistics.NewBuryPointLogs().AsyncBuryPointLogs() //埋点日志落地
		//go statistics.NewAdjustSta().AsyncAdjustSta() //同步adjuststa数据并上报数数平台
	}, func(ex exp.Exception) {
		log.LogError("async_excepition", ex)
	})

	for { //阻塞进程,让程序一直跑
		time.Sleep(10 * time.Second)
	}
}
