package config

import (
    "Crazy_Push/configs"
)

const(
    SUCCESS                               = 0 //成功
    REQUEST_PARAM_ERROR                   = -1               // 请求参数错误
    SYSTEM_ERROR                          = -1000            // 系统异常
    UNAUTHORIZED_REQUEST                  = -1001            // 未经授权的请求,Token错误
    API_TIME_EXPIRED                      = -1002            // Token过期
    API_FREQUENT_REQUESTS                 = -1003            // 接口频繁请求
)

var ErrList = map[int]string {
    SUCCESS:                               "成功",
    REQUEST_PARAM_ERROR:                   "请求参数错误",
    SYSTEM_ERROR:                          "系统异常",
    API_FREQUENT_REQUESTS:                 "接口频繁请求",
}

//获取错误信息
func GetErrMsg(errId int) string {
    if ErrList[errId] == "" {
        return "未知消息"
    }
    return ErrList[errId]
}

//获取系统服务配置
func GetServerConf() map[string]string {
    return sysConfig.GetServerConf()
}
