package routers

import (
	"time"

	"Crazy_Push/cmd/statistics/controllers"
	"Crazy_Push/models/utils"
	"github.com/gin-contrib/cors"
	"github.com/gin-gonic/gin"
)

func RegisterRouters() *gin.Engine {
    r := gin.New()
    r.Use(utils.Recovery()) //异常处理
	r.Use(cors.New(cors.Config{
        AllowOrigins:     []string{"*"},
        AllowMethods:     []string{"POST", "PATCH"},
        AllowHeaders:     []string{"Origin"},
        ExposeHeaders:    []string{"Content-Length"},
        AllowCredentials: true,
        AllowOriginFunc: func(origin string) bool {
            return true
        },
        MaxAge: 12 * time.Hour,
	}))
    r.POST("/index/Report/play", controllers.PlayReport) //小游戏时长统计
	r.POST("/index/Report/event", controllers.EventReport) //客户端日志上报
	r.GET("/index/adjust/callbacks", controllers.AdjustCallbacks) //adjust上报(来自adjust回调)
	//r.GET("/index/Adjust/callbacks", controllers.AdjustCallbacks) //adjust上报
    r.GET("/index/Adjust/recallbacks", controllers.AdjustReCallbacks) //adjust再归因上报
    r.GET("/index/adjust/recallbacks", controllers.AdjustReCallbacks) //adjust再归因上报

    return r
}
