package main

import (
	"fmt"
	"runtime"
	"time"

	"Crazy_Push/core/exp"
	"Crazy_Push/models/games"
	//"Crazy_Push/models/log"
	"Crazy_Push/configs"
	"Crazy_Push/models/ta"
)

func main() {
	runtime.GOMAXPROCS(2) //只跑单核
	event := []string{"user_setOnce",
		"user_set",
		"user_create",
		"new_device",
		"user_login",
		"level_up",
		"sign",
		"slot_machine",
		"attack",
		"steal",
		"building",
		"tap_fruit",
		"pet_unlock",
		"pet_feed",
		"pet_up",
		"order_finish",
		"invite_success",
		"activity_collect_reward",
		"activity_rank_reward_layer",
		"activity_rank_reward_ranking",
		"activity_coinslot",
		"activity_coinslot_quest",
		"activity_egg_knock",
		"activity_egg_rebirth",
		"activity_egg_end",
		"activity_pass_reward",
		"activity_pass_levelup",
		"chest",
		"chest_sp",
		"card_send",
		"card_accept",
		"card_ask",
		"card_respond",
		"spin_send",
		"spin_accept",
		"coin_send",
		"coin_accept",
		"cardset_complate",
		"resource_obtain",
		"resource_cost",
		"resource_list",
		"ad_cost",
		"total_recharge",
		"random_gold_card",
		"joker_card_trade",
		"spins_master",
		"guide",
		"help_repair",
		"activity_puzzle_obtain_piece",
		"activity_puzzle_reward",
	}
	fmt.Println("请求Appid:" + sysConfig.GetTaAppId() + "请求地址:" + sysConfig.GetTaServer())
	exp.Try(func() {
		ta.SetChan(event)
		taInstance := ta.NewTa()
		//taInstance.WaitGroup.Add(1)
		for _, v := range event {
			go taInstance.TaDispatch(v) //调度
			go func(eventName string) {
				for {
					taInstance.PopDataFromRedis(eventName)
					//time.Sleep(3 * time.Second) //没有数据了,休息30秒
				}
			}(v)
		}
		//taInstance.WaitGroup.Wait()
	}, func(ex exp.Exception) {
		//log.LogError("async_excepition", ex)
		PanicEvent2()
	})
	for { //阻塞进程,让程序一直跑
		time.Sleep(3 * time.Second)
	}
}

func PanicEvent2() {
	en := games.NewEnWeChat()
	timeStr := time.Now().Format("2006/01/02 15:04")
	en.Send("【GO-数数统计警报】异常退出,退出时间("+timeStr+")(测试)", []string{"richard", "luokunpeng", "shaocheng"}, []uint{}, 0)
}
