package sysConfig

var (
	ENV    = "dev"
	MQOPEN = 0
	//FIXEDZONENUM = 8 * 3600 //东八区
)

var (
	serverConfig = map[string]map[string]string{
		"dev": map[string]string{ //开发服
			"natsServer": "nats://192.168.10.19:4222",
			"nsqServer":  "120.78.8.90:4150",
			"nsqClient":  "120.78.8.90:4161",
			"type":       "user",
			//"type":           "token",
			//"token":          "0SHQbR4l",
			"natsPubSubUser": "a", //订阅、发布两种权限
			"natsPubSubPwd":  "a",
			"natsSub":        "a", //订阅权限
			"natsSubPwd":     "a",
			"natsPub":        "a", //发布权限
			"natsPubPwd":     "a",
		},
		"test": map[string]string{ //测试服
			"natsServer": "nats://120.78.8.90:4222",
			"nsqServer":  "120.78.8.90:4150",
			"nsqClient":  "120.78.8.90:4161",
			"type":       "user",
			//"type":           "token",
			//"token":          "0SHQbR4l",
			"natsPubSubUser": "a", //订阅、发布两种权限
			"natsPubSubPwd":  "a",
			"natsSub":        "b", //订阅权限
			"natsSubPwd":     "b",
			"natsPub":        "c", //发布权限
			"natsPubPwd":     "c",
		},
		"prod": map[string]string{ //正式服
			"natsServer": "nats://47.90.250.184:4222",
			"nsqServer":  "120.78.8.90:4150",
			"nsqClient":  "120.78.8.90:4161",
			"type":       "user",
			//"type":           "token",
			//"token":          "0SHQbR4l",
			"natsPubSubUser": "a", //订阅、发布两种权限
			"natsPubSubPwd":  "a",
			"natsSub":        "b", //订阅权限
			"natsSubPwd":     "b",
			"natsPub":        "c", //发布权限
			"natsPubPwd":     "c",
		},
	}
	taAppids = map[string]string{
		"dev":  "b1520299affe4f60bd7a1deac7f3a4ed",
		"prod": "860a7f3b75d1486c9cb0b088380ebdd2",
	}

	taServers = map[string]string{
		"dev":  "https://shushu.crazyspin.vip/logagent", //测试服走公网
		"prod": "http://172.22.107.116:80/logagent",     //正式服走内网
	}

	fixedZoneNum = map[string]int{
		"dev":  8 * 3600, //东八区
		"prod": 0,
	}
	taData = map[string]string{
		"dev":  "/mnt/www/logs/",
		"prod": "/mnt/www/logs/",
	}
	logpath = map[string]string{
		"dev":  "/mnt/www/logs/",
		"prod": "/mnt/www/logs/",
	}
)

func GetServerConf() map[string]string {
	if len(serverConfig[ENV]) <= 0 {
		return map[string]string{}
	}
	return serverConfig[ENV]
}

func GetFixedZoneNum() int {
	return fixedZoneNum[ENV]
}

func IsDebugMode() bool {
	if ENV == "dev" {
		return true
	}
	return false
}

//数数平台appid
func GetTaAppId() string {
	return taAppids[ENV]
}

//数数平台服务请求地址
func GetTaServer() string {
	return taServers[ENV]
}
func GetTaUpDataPath() string {
	return taData[ENV]
}

//获取日志存储路径
func GetLogPath() string {
	return logpath[ENV]
}
