package sysConfig

import (
	"fmt"
	"sort"
	"strconv"

	"Crazy_Push/core/function"
)

var (
	//mysql相关
	MYSQLGAMEHOST = map[string]string{
		"prod": "rm-0xi79de2clzcgkf2g.mysql.rds.aliyuncs.com", //正式服游戏业务数据库
		"dev":  "127.0.0.1",                                   //测试服游戏数据库
	}
	MYSQLCAMAIGNHOST = map[string]string{
		"prod": "rm-0xizw8sr051zqta3e.mysql.rds.aliyuncs.com", // 后台服务器内网ip
		"dev":  "127.0.0.1",
	}
	MYSQLSTATISTICSHOST = map[string]string{
		"prod": "rm-0xizw8sr051zqta3e.mysql.rds.aliyuncs.com", //正式服统计数据库
		"dev":  "127.0.0.1",                                   //开发服统计数据库
	}
	MYSQLUSER = map[string]string{
		"prod": "aroot",
		"dev":  "root",
	}
	MYSQLCAMAIGNUSER = map[string]string{
		"prod": "aroot",
		"dev":  "root",
	}
	MYSQLPWD = map[string]string{
		"prod": "ekkodG039jtckmw99",
		"dev":  "crazy_coin2020",
	}
	MYSQLCAMAIGNPWD = map[string]string{
		"prod": "dkeodd0293ngrO90e",
		"dev":  "crazy_coin2020",
	}
	MYSQLPORT        = "3306"
	MYSQLCAMAIGNPORT = map[string]string{
		"prod": "3306",
		"dev":  "3306",
	}
	//redis相关-业务
	RDSGAMEHOST = map[string]string{
		"prod": "r-0xinmfjpq4j0hqz2eo.redis.rds.aliyuncs.com",
		//"dev":  "127.0.0.1",
		"dev": "127.0.0.1",
		//"dev":  "r-wz96x2ryuqm7gvjhqf.redis.rds.aliyuncs.com",
	}
	RDSGAMEAUTH = map[string]string{
		"prod": "deodkc0d9jIu8d9",
		"dev":  "crazy_coin2020",
	}
	RDSGAMEPORT = "6379"
	//redis-统计
	RDSSTATISTICSHOST = map[string]string{
		"prod": "r-0xicr326g4qr91cmg9.redis.rds.aliyuncs.com",
		"dev":  "127.0.0.1",
		//"dev":  "127.0.0.1",
		//"dev": "r-wz96x2ryuqm7gvjhqf.redis.rds.aliyuncs.com",
	}
	RDSSTATISTICSAUTH = map[string]string{
		"prod": "dejo9e0IIokeoc",
		"dev":  "crazy_coin2020",
	}
	RDSSTATISTICSPORT = "6379"

	RDSCAMPAIGNSHOST = map[string]string{
		"prod": "r-0xicr326g4qr91cmg9.redis.rds.aliyuncs.com",
		"dev":  "127.0.0.1",
		//"dev": "r-wz96x2ryuqm7gvjhqf.redis.rds.aliyuncs.com",
	}
	RDSCAMPAIGNAUTH = map[string]string{
		"prod": "dejo9e0IIokeoc",
		"dev":  "crazy_coin2020",
	}
	RDSCAMPAIGNPORT = "6379"

	MYSQLSTR = "%s:%s@tcp(%s:%s)/%s?charset=utf8&parseTime=True&loc=Local"
)

// Todo：mysql地址去除硬编码，参数拼接
var mysqlConfig = map[string]map[int]string{
	//"main.api_user": map[int]string {
	//    360:   "root:123456@tcp(rm-0xi79e2y8023q15z1.mysql.rds.aliyuncs.com:3306)/crazyGod_api_user?charset=utf8&parseTime=True&loc=Local",
	//},

	"main.api_user": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_user"),
	},

	"main.api_paymentnew": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_paymentnew"),
	},
	"main.api_userlevel": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_userlevel"),
	},
	"main.api_config": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_config"),
	},
	"main.api_payment": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_paymentnew"),
	},
	"main.api_achievement": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_achievement"),
	},
	"main.api_statistics": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLSTATISTICSHOST[ENV], MYSQLPORT, "crazyGod_api_statistics"),
	},
	"main.log": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLSTATISTICSHOST[ENV], MYSQLPORT, "crazyGod_log"),
	},
	"main.api_adjuststa": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_adjuststa"),
	},
	"main.admin": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLUSER[ENV], MYSQLPWD[ENV], MYSQLGAMEHOST[ENV], MYSQLPORT, "crazyGod_api_admin"),
	},
	"main.campaign": map[int]string{
		360: fmt.Sprintf(MYSQLSTR, MYSQLCAMAIGNUSER[ENV], MYSQLCAMAIGNPWD[ENV], MYSQLCAMAIGNHOST[ENV], MYSQLCAMAIGNPORT[ENV], "crazygod_roport_statistics"),
	},
	//"circle.price":  map[int]string {
	//    6:     fmt.Sprintf(MYSQLSTR, MYSQLUSER, MYSQLPWD, MYSQLHOST, MYSQLPORT, "stock_price_6"),
	//    12:    fmt.Sprintf(MYSQLSTR, MYSQLUSER, MYSQLPWD, MYSQLHOST, MYSQLPORT, "stock_price_12"),
	//},
}

var redisConfig = map[string]map[string]string{
	"main.games": map[string]string{
		"host": fmt.Sprintf("%s:%s", RDSGAMEHOST[ENV], RDSGAMEPORT),
		"auth": RDSGAMEAUTH[ENV],
	},
	"main.statistics": map[string]string{
		"host": fmt.Sprintf("%s:%s", RDSSTATISTICSHOST[ENV], RDSSTATISTICSPORT),
		"auth": RDSSTATISTICSAUTH[ENV],
	},
	"main.campaign": map[string]string{
		"host": fmt.Sprintf("%s:%s", RDSCAMPAIGNSHOST[ENV], RDSCAMPAIGNPORT),
		"auth": RDSCAMPAIGNAUTH[ENV],
	},
}

//
//var redisConfig = map[string]map[string]string{
//    "main.games": map[string]string {
//        "host": "127.0.0.1:6379",
//        "auth": "123456",
//    },
//    "main.statistics": map[string]string {
//        "host": "127.0.0.1:6380",
//        "auth": "123456",
//    },
//}
////var redisConfig = "172.17.0.3:6379"
//var redisConfig = "127.0.0.1:6379"
//var redisAuth = "123456"

func GetSqlConf(serverName string, keys ...string) (string, int) {
	var conf string
	if len(mysqlConfig[serverName]) <= 0 {
		return conf, 360
	}

	circleKey := 360
	if len(keys) == 0 {
		return mysqlConfig[serverName][circleKey], circleKey
	}

	if function.IsNumeric(keys[0]) {
		circleKey, _ = strconv.Atoi(keys[0])
	} else {
		circleKey = int(function.Crc32(keys[0]))
	}

	var circleKeys []int
	for k, _ := range mysqlConfig[serverName] {
		circleKeys = append(circleKeys, k)
	}
	sort.Sort(sort.IntSlice(circleKeys))
	circleKey = circleKey % 360
	for _, v := range circleKeys {
		if circleKey < v {
			circleKey = v
			break
		}
	}

	return mysqlConfig[serverName][circleKey], circleKey
}

/**/
func GetRedisConf(rdServerName ...string) (string, string) {
	name := ""
	if len(rdServerName) == 0 {
		name = "main.games"
	} else {
		name = rdServerName[0]
	}
	return redisConfig[name]["host"], redisConfig[name]["auth"]
}

//func GetRedisAuth() string {
//    return redisAuth
//}
