package exp

import (
	"fmt"
	"runtime/debug"
)

/*
   Create Time：2021/1/20 19:47
   Author：王勇攀
*/
/*
   Description:
*/

type ExType int

type Exception struct {
	Err   string
	Stack string
}

func Try(fun func(), handler func(ex Exception)) {
	defer func() {
		if err := recover(); err != nil {
			handler(Exception{
				Err:   fmt.Sprintf("%s", err),
				Stack: string(debug.Stack()),
			})
		}
	}()
	fun()
}

