package function

import (
	"os"
	"os/signal"
	"syscall"
)

var (
    onlyOneSignalHandler = make(chan struct{})
    shutdownSignals = []os.Signal{os.Interrupt, syscall.SIGTERM}
)

func CloseHandler() (stopCh <-chan struct{}) {
	close(onlyOneSignalHandler) // panics when called twice
	stop := make(chan struct{})
	c := make(chan os.Signal, 1) //1表示chan的长度,输入多少次,就可以实现Control+c执行动作多少次
	signal.Notify(c, shutdownSignals...)
	go func() {
		<-c
		os.Exit(1) //Exit directly.
	}()
	return stop
}

//根据时间戳获取季度
func GetQueueByStamp(stamp float64) (string, string, string) {
    tmp := Date("01/2006", int64(stamp))
    queue, tmp1 := GetQueue(tmp[0:2])
    return tmp[3:], queue, tmp[3:]+"-"+tmp1
}

//根据日期获取季度
//func GetQueueByDay(format string, day string) (string, string) {
func GetQueueByDay(day string) (string, string, string) {
    queue, tmp := GetQueue(day[4:6])
    return day[0:4], queue, day[0:4]+"-"+tmp
}

func GetQueue(month string) (string, string) {
    queue, day := "", ""
    switch month {
       case "01", "02", "03":
           queue, day = "Q1", "03-31"
       case "04", "05", "06":
           queue, day = "Q2", "06-30"
       case "07", "08", "09":
           queue, day = "Q3", "09-30"
       case "10", "11", "12":
           queue, day = "Q4", "12-31"
    }
    return queue, day
}
