package sql

import (
    "os"
    "fmt"
    "sync"
    "gorm.io/gorm"
    _ "github.com/go-sql-driver/mysql"
    "gorm.io/driver/mysql"
)

var (
    mysqlInsts sync.Map
)

//返回单例实例
func GetMysqlDb(argStr string, key string) *gorm.DB {
    if v, ok := mysqlInsts.Load(key); ok {
        return v.(*gorm.DB)
    }

    tmp, err := gorm.Open(mysql.Open(argStr), &gorm.Config{})
    //tmp, err := gorm.Open("mysql", argStr)
    //tmp.LogMode(true)

    //数据库连接失败
    if err != nil {
        fmt.Println("connect db error:", err)
        os.Exit(-1)
    }
    mysqlInsts.Store(key, tmp)
    v, _ := mysqlInsts.Load(key)
    return v.(*gorm.DB)
}

//关闭所有连接
func CloseDb() {
	mysqlInsts.Range(func(k, v interface{}) bool {
        //v.(*gorm.DB).Close()
        mysqlInsts.Delete(k)
		return true
    })
}
