package ab

import (
    "fmt"
    "net/http"
    "encoding/json"
    "sync"

    "Crazy_Push/models/dblogic"
    "Crazy_Push/models/okeys"
    //"Crazy_Push/core/mlog"
)

var (

    //firebaesHeader = make(http.Header)
	funnelhttpClient = make(chan *httpClient, 50) // Channel for new join users.

    funnelUrl = "http://172.22.107.81:8080"
)

type funnel struct {
    Header http.Header
    WaitGroup *sync.WaitGroup
}

func NewFunnel() *funnel {
    header := make(http.Header)
    header.Set("Content-type", "application/json")
    return &funnel{
        Header: header,
        WaitGroup: &sync.WaitGroup{},
    }
}

//json encode
func (base *funnel) ParsePushEncode(params *PushMsg) string {
    str, err := json.Marshal(params)
    if err != nil {
        return ""
    }
    return string(str)
}

func (base *funnel) NewPushEvent(str string) {
    funnelhttpClient <- &httpClient{Params: str, Url: funnelUrl, Header: base.Header, Key: str}
    return
}

//发送请求并等待响应
func (base *funnel) ReqAndRspDeal(client *httpClient) {
    defer base.WaitGroup.Done()
    res, code := client.PushRequest()
    if code == 200 {
        fmt.Println("推送成功", res)
        client = nil
        return
    }
    client = nil
    return
}

//调度
func (base *funnel) HttpDispatch() {
	for {
		select {
		case client := <-funnelhttpClient:
            base.WaitGroup.Add(1)
            go base.ReqAndRspDeal(client)
		case <-interrupt:
            close(funnelhttpClient)
            close(interrupt)
            base.WaitGroup.Wait()
            return //退出
        //default:
        //    time.Sleep(3 * time.Millisecond) //3毫秒推一次,频率太高http请求无响应
		}
	}
}

func (base *funnel) PopDataFromRedis() (string, error) {
    return dblogic.R("Statistics").RPop(okeys.CommonKeys("Funnel"))
}
