package ab

import (
    "fmt"
    "io/ioutil"
    "net/http"
    "net/url"
    "strings"
    "time"

    //"encoding/json"
    //"bytes"
)

type httpClient struct {
    Url string
    Params string
    Header http.Header
    Key string
}

func NewHttpClient(url string, params string) *httpClient {
    return &httpClient{Url: url, Params: params}
}

//全服满足条件玩家推送消息
func (client *httpClient)PushRequest() (string, int) {
    return PostRequest(client.Url, client.Params, client.Header)
}

//http请求
func (client *httpClient)TestRequest() (string, int) {
    return GetRequest(client.Url, client.Params, client.Header)
}

func ParseUrlEncode(params map[string]string) string {
    args := url.Values{}
    for k, v := range params {
        args.Add(k, v)
    }
    return args.Encode()
}

func Request(rurl string, method string, params string, header http.Header) (string, int) {
    client := &http.Client{
        Timeout: time.Duration(25 * time.Second),
    }
    reqest, _ := http.NewRequest(method, rurl, strings.NewReader(params))
    if header != nil {
        reqest.Header = header
    }

    resp, err := client.Do(reqest)
    if err != nil {
        fmt.Println("request error:", err)
        return "", 400
    }
    defer resp.Body.Close()

    body, _ := ioutil.ReadAll(resp.Body)
    return string(body), resp.StatusCode
}

//`crazyGod_api_user`.`t_mobile`表andorid用户
//lid:用户类型识别, sid:,device:osVersion:,mobile_request:,
func PostRequest(url string, params string, header http.Header) (string, int) {
    return Request(url, "POST", params, header)
}

func GetRequest(url string, params string, header http.Header) (string, int) {
    return Request(url, "GET", params, header)
}

//入队，出队
//push.php -> push
//fireBasePushByRedisList
