//数据库逻辑接口
package dblogic

import (
    "fmt"
    //"github.com/jinzhu/gorm"
    "os"

    "Crazy_Push/configs"
    "Crazy_Push/core/rediscli"
    "Crazy_Push/core/sql"
    "Crazy_Push/models/tables"

    //"github.com/go-redis/redis"
    "gorm.io/gorm"
	"gorm.io/gorm/clause"
)

const (
	Circle = "circle"
	Main = "main"
)

//mysql表
const (
    User = "user"
    Achievement = "achievement"
    Config = "config"
    Statistics = "statistics"
    Payment = "payment"
    UserLevel = "userlevel"
)

//忽略重复
func MySqlIgnore() clause.Insert {
    return clause.Insert{Modifier: "IGNORE"}
}

func M(serverName string, keys ...string) *gorm.DB {
    server := tables.GetServerConf(serverName)
    //环形库一定要带参数
    sType := Main
    if server[0:6] == Circle {
        sType = Circle
    }

    if sType == Circle && len(keys) == 0 {
        fmt.Println("circle db must use circle key")
        os.Exit(-2)
    }

    conf, index := sysConfig.GetSqlConf(server, keys...)
    if conf == "" {
        fmt.Println("db config data not found")
        os.Exit(-3)
    }
    instKey := serverName
    if sType == Circle {
        instKey = fmt.Sprintf("%s%d", instKey, index)
    }
    return sql.GetMysqlDb(conf, instKey)
}

func R(serverName ...string) *redisCli.RedisClient {
    key := tables.GetRdConf(serverName...)
    host, auth := sysConfig.GetRedisConf(key)
    params := []string{}
    if len(serverName) > 1 {
        params = serverName[1:]
    }
    return redisCli.GetRedis(host, auth, params...)
}

//关闭单个redis实例
func CloseRd(serverName ...string) {
    key := tables.GetRdConf(serverName...)
    host, auth := sysConfig.GetRedisConf(key)
    key = host + auth
    if len(serverName) > 1 {
        key = key + serverName[1]
    }
    redisCli.CloseRedis(key)
}
