package games

import (
	"Crazy_Push/models/dblogic"
	"Crazy_Push/models/utils"
	"bytes"
	"fmt"
	"net/http"
	"strconv"
	"strings"
)

var (
	CorpId     = "wwab4cd61391c809f9"
	CorpSecret = "dFohBcprezGR1qcWURjOgTIYuAm2jmLtgnYkhckgA0I"
	AgentId    = 1000008
	UidList    = []string{"luokunpeng"}
	SendUrl        = "https://qyapi.weixin.qq.com/cgi-bin/message/send"
	AccessTokenUrl = "https://qyapi.weixin.qq.com/cgi-bin/gettoken"
	DepartmentUrl  = "https://qyapi.weixin.qq.com/cgi-bin/department/list"
	UserUrl        = "https://qyapi.weixin.qq.com/cgi-bin/user/simplelist"
	TagUrl         = "https://qyapi.weixin.qq.com/cgi-bin/tag/list"
	TagUserUrl     = "https://qyapi.weixin.qq.com/cgi-bin/tag/get"
)

type EnWeChat struct {

}

type EnWeChatAccessToken struct {
	ErrCode uint `json:"errcode"`
	ErrMsg string `json:"errmsg"`
	AccessToken string `json:"access_token"`
	ExpiresIn uint `json:"expires_in"`
}

type DepartmentList struct {
	ErrCode uint `json:"errcode"`
	ErrMsg string `json:"errmsg"`
	Department []Department `json:"department"`
}

type Department struct {
	ID uint `json:"id"`
	Name string `json:"name"`
	NameEn string `json:"name_en"`
	ParentId uint `json:"parentid"`
	Order uint `json:"order"`
}

type UserListByDepartment struct {
	ErrCode uint `json:"errcode"`
	ErrMsg string `json:"errmsg"`
	UserList []DepartmentUserList `json:"userlist"`
}

type DepartmentUserList struct {
	UserId string `json:"userid"`
	Name string `json:"name"`
	Department []uint `json:"department"`
	OpenUserId string `json:"open_userid"`
}

type TagUserList struct {
	ErrCode uint `json:"errcode"`
	ErrMsg string `json:"errmsg"`
	TagName string `json:"tagname"`
	UserList []TagUser `json:"userlist"`
	PartyList []uint `json:"partylist"`
}

type TagUser struct {
	UserId string `json:"userid"`
	Name string `json:"name"`
}

type Message struct {
	ToUser string `json:"touser"`
	ToParty string `json:"toparty"`
	MsgType string `json:"msgtype"`
	AgentId int `json:"agentid"`
	Text struct {
		Content string `json:"content"`
	} `json:"text"`
	Safe int `json:"safe"`
}


func NewEnWeChat() *EnWeChat {
	return &EnWeChat{}
}

/**
获取 AccessToken
 */
func (en *EnWeChat) getAccessToken() string {
	redisKey := "ENWECHATACCESSTOKEN"
	token,_ := dblogic.R("games").Get(redisKey)
	if token != ""{
		return token
	}
	accessTokenData := utils.ActionGet(AccessTokenUrl + "?corpid="+CorpId+"&corpsecret="+CorpSecret, map[string]string{},true)
	enWeChatAccessToken := &EnWeChatAccessToken{}
	_ = json.Unmarshal([]byte(accessTokenData),enWeChatAccessToken)
	if enWeChatAccessToken.AccessToken != ""{
		_,_ = dblogic.R("games").Set(redisKey,enWeChatAccessToken.AccessToken,7000)
		return enWeChatAccessToken.AccessToken
	}
	return ""
}

func (en * EnWeChat) getDepartmentList(dl []uint) []uint {
	token := en.getAccessToken()
	outDl := []uint{}
	if token != ""{
		DepartmentListStr := utils.ActionGet(DepartmentUrl + "?access_token=" + token, map[string]string{},true)
		departmentList    := &DepartmentList{}
		_ = json.Unmarshal([]byte(DepartmentListStr),departmentList)
		for _,x := range departmentList.Department{
			for _,d := range dl{
				if x.ID == d{
					outDl = append(outDl,d)
				}
			}
		}
	}
	return outDl
}

func (en * EnWeChat) getUserListByDepartment(dl []uint) []string {
	token := en.getAccessToken()
	dl = en.getDepartmentList(dl)
	uId := []string{}
	for _,x := range dl{
		xStr := strconv.Itoa(int(x))
		DepartmentUserListStr := utils.ActionGet(UserUrl + "?access_token=" + token + "&department_id=" + xStr , map[string]string{},true)
		userListByDepartment    := &UserListByDepartment{}
		_ = json.Unmarshal([]byte(DepartmentUserListStr),userListByDepartment)
		for _,x := range userListByDepartment.UserList{
			uId = append(uId,x.UserId)
		}
	}
	return uId
}

func (en *EnWeChat) getUserListByTagId(tagId uint) []string {
	token := en.getAccessToken()
	tagStr:= strconv.Itoa(int(tagId))
	tagUserListStr := utils.ActionGet(TagUserUrl + "?access_token=" + token + "&tagid=" + tagStr , map[string]string{},true)
	tagUserList    := &TagUserList{}
	uId := []string{}
	_ = json.Unmarshal([]byte(tagUserListStr),tagUserList)
	for _,x := range tagUserList.UserList{
		uId = append(uId,x.UserId)
	}
	return uId
}

/**
发送消息 AccessToken
*/
func (en *EnWeChat) Send(message string,uidArr []string,department []uint,tagId uint) string {
	if len(uidArr) == 0{
		if len(department) != 0 {
			uidArr = en.getUserListByDepartment(department)
		}else if tagId != 0{
			uidArr = en.getUserListByTagId(tagId)
		}
	}
	if len(uidArr) != 0 {
		toUser := strings.Join(uidArr, ",")
		token := en.getAccessToken()
		msg := Message{
			ToUser: toUser,
			MsgType: "text",
			AgentId: AgentId,
			Safe: 0,
			Text: struct {
				Content string `json:"content"`
			}{Content: message},
		}
		sendMsg, _ := json.Marshal(msg)
		client := &http.Client{}
		req, _ := http.NewRequest("POST",SendUrl + "?access_token=" + token, bytes.NewBuffer([]byte(sendMsg)))
		req.Header.Set("Content-Type", "application/json")
		req.Header.Set("charset","UTF-8")
		resp, err := client.Do(req)
		if err != nil {
			fmt.Println(err.Error())
		}
		defer resp.Body.Close()
	}
	return ""
}
