package games

import (
    "strconv"
    "encoding/base64"
    "math/rand"
    "time"
    "math"
    "strings"
	//"encoding/json"
    //"strings"
)

const (
    ENRANDSNUM = 16
)

var (
    CmdReqList = map[string]string {
        "userBind":               "0x1001",
        "userAssetsInfo":         "0x1002",
        "userBindRec":            "0x4006",
        "userLog":                "0x5006",
        "userHeartbeat":          "0x2008",
        "userHeartbeatRec":       "0x600d",

        "miningUp":               "0x3001",
        "miningUpRec":            "0x3002",
        "slotGetShowSlot":        "0x3003",
        "SlotGetShowSlotRec":     "0x3004",
		"userTest":               "0x3005",
        "repeatLoginRec":         "0x4004",

        "chatInit":               "0x5100", //聊天初始化
        "chatsendToFriend":       "0x5101", //聊天发到好友
        "chatsendToWorld":        "0x5102", //聊天发到世界
        "chataddToWorld":         "0x5103", //聊天加入世界
        "chatleaveWorld":         "0x5104", //聊天离开世界
        "chatdeleteCache":        "0x5105", //删除聊天记录
        "chatgift":               "0x5106", //领取礼物聊天
        "chatgiftReced":          "0x5107", //领取礼物通知好友

        "chatInitRec":            "0x5200", //聊天初始化回包
        "chatsendToFriendRec":    "0x5201", //聊天发到好友回包
        "chatsendToWorldRec":     "0x5202", //聊天发到世界回包
        "chataddToWorldRec":      "0x5203", //聊天加入世界回包
        "chatleaveWorldRec":      "0x5204", //聊天离开世界回包
        "chatdeleteCacheRec":     "0x5205", //删除聊天记录回包
        "chatgiftRec":            "0x5206", //领取礼物聊天回包
        "chatgiftRecedRec":       "0x5207", //领取礼物通知好友回包

        "chatsendToFriendMsg":    "0x5211", //聊天接收到好友消息
        "chatsendToWorldMsg":     "0x5212", //聊天接收到世界消息
        "chatgiftRecMsg":         "0x5213", //通知世界刷新礼物信息
        "chatgiftRecedMsg":       "0x5214", //通知好友刷新礼物信息

        //"slotBalloonReward":      "0x2101",
        "activityTreasureReward": "0x2102",
        "slotBalloonReward":      "0x2103",
    }

    CmdRspList = map[string]string {
        "slotGetShowSlotRec":      "0x3004",
        "slotElementSaleId":       "0x3005",
        "slotBalloonRec":          "0x1201",
        "slotBalloonRewardRec":    "0x1202",
        "announcementRec":         "0x1203",  // 走马灯
        "specialOfferRec":         "0x1204",
        "vipRec":                  "0x1205",
        "levelHelpBuildOperation": "0x1206",
        "jackPotPool":             "0x1207",
        "jackPotReward":           "0x1208",
        "acRankLimitTimeReward":   "0x1209",
        "userAssetsInfo":          "0x1210",
        "activityDoubleSpins":     "0x1211",
        "defensePetSkill":         "0x1212",
        "attackPetSkill":          "0x1213",
        "stealProtected":          "0x1214",
        "announcement":            "0x1215",  // 停服公告
        "updateCurMaxLevel":       "0x1216",
        "inviteUpdate":            "0x1217",
        "activityChangeStatus":    "0x1218",
        "configRefresh":           "0x1219",
        "payBet":                  "0x1220",
        "activityTreasureReward":  "0x1221",
        "activityChangeStatusNew": "0x1222",//4642 新活动推送
        "rewardInviteUrl":         "0x1223",
        "activityCommonPush":      "0x1224", //4644 活动公用推送
        "slotAttackObject":        "0x1225", //默认攻击对象
        "activityFlush":           "0x1226",//4646更新活动信息
        "trafficPermitAddNum":     "0x1227",//完成通行证任务
    }
)

func GetReqCmd(name string) string {
    if _, ok := CmdReqList[name]; !ok {
        return "0"
    }

    c, _ := strconv.ParseInt(CmdReqList[name][2:], 16, 32)
    return  strconv.FormatInt(c, 10)
}

type respMsg struct {
    Cmd string `json:"cmd"`
    Code int `json:"code"`
    Msg string `json:msg`
    Data string `json:"data"`
}

//消息发送前的编码
func RspMsg(cmd string, code int, msg string, data string) string {
    res := &respMsg{ Cmd: cmd, Code: code, Msg: msg, Data: data }
    resStr, _ := json.Marshal(res)
    return MsgEncode(string(resStr))
}

func GetRandomString(l int) string {
	str := "0123456789abcdefghijklmnopqrstuvwxyz"
	bytes := []byte(str)
	result := []byte{}
	r := rand.New(rand.NewSource(time.Now().UnixNano()))
	for i := 0; i < l; i++ {
		result = append(result, bytes[r.Intn(len(bytes))])
	}
	return string(result)
}

//消息编码
func MsgEncode(str string) string {
    str = base64.StdEncoding.EncodeToString([]byte(str))
    index := int(math.Floor(float64(len(str))/2) - 1)
    randStr := GetRandomString(ENRANDSNUM)
    out := str[0:index]+randStr+str[index:]
    return out[0:1]+randStr[0:1]+out[1:]
}

//消息解码
func MsgDecode(str string) string {
    if len(str) < ENRANDSNUM + 2 {
        return ""
    }
    str = str[0:1]+str[2:]
    length := len(str)

    index := int(math.Floor(float64(length - ENRANDSNUM)/2)) - 1
    str = str[0:index]+str[index+ENRANDSNUM:]
    ret, _ := base64.StdEncoding.DecodeString(str)
    return string(ret)
}

//通过解码的消息字符串解出请求参数
func DecodeParamStr(str string) map[string]string {
    res := map[string]string{}
    str = strings.Trim(str, "&")
    tmp := strings.Split(str, "&")
    if len(tmp) < 1 {
        return res
    }
    for _, v := range tmp {
        splitRet := strings.Split(v, "=")
        if len(splitRet) != 2 {
            continue
        }
        res[splitRet[0]] = splitRet[1]
    }
    return res
}

//通过请求参数param解析出参数列表
func GetReqParams(str string) map[string]string {
    return DecodeParamStr(MsgDecode(str))
}
