package log

//日志类
import (
	"time"
    "sync"

    "Crazy_Push/configs"

	rotatelogs "github.com/lestrrat-go/file-rotatelogs"
	log "github.com/sirupsen/logrus"
)

//Todo:改为动态获取地址
var(
    pathPrefix = sysConfig.GetLogPath()
    //logsAge    = 7 * 24 * time.Hour
    logs sync.Map
)

func LogInst(name string) *log.Logger {
    path := pathPrefix+name+"/go.log"
    if _, ok := logs.Load(name); !ok {
        writer, _ := rotatelogs.New(
            path+".%Y%m%d%H",
            rotatelogs.WithLinkName(path),
            rotatelogs.WithMaxAge(7*24*time.Hour), //
            rotatelogs.WithRotationTime(time.Duration(60)*time.Second),
        )
        logger := log.New()
        logger.SetFormatter(&log.JSONFormatter{TimestampFormat: "2006-01-02 15:04:05"})
        logger.SetOutput(writer)
        logger.WithField("log_module", name)
        logs.Store(name, logger)
    }
    v, _ := logs.Load(name)
    return v.(*log.Logger)
}

//自定义info日志
func LogInfo(name string, args ...interface{}) {
    LogInst(name).WithFields(log.Fields{"log_module": name}).Info(args...)
}

//自定义warning日志
func LogWarn(name string, args ...interface{}) {
    LogInst(name).WithFields(log.Fields{"log_module": name}).Warn(args...)
}

//自定义Error日志
func LogError(name string, args ...interface{}) {
    LogInst(name).WithFields(log.Fields{"log_module": name}).Error(args...)
}

//自定义Panic日志
func LogPanic(name string, args ...interface{}) {
    LogInst(name).WithFields(log.Fields{"log_module": name}).Panic(args...)
}
