package nsq

import (
    "fmt"
    //"time"
	"os"
    //"sync"
    "Crazy_Push/configs"

    "github.com/nsqio/go-nsq"
)


var (
    nsqConf = sysConfig.GetServerConf()
    nsqHttpServe *nsqServer
    //////////////////////////////////
    nsqTopic = "test.b"
    //////////////////////////////////
    nsqChan  = make(chan [2]string, 50) // Channel for new join users.
	interrupt = make(chan os.Signal, 1)
)

// 默认配置
type nsqServer struct {
    Conn *nsq.Producer
}

type nsqClient struct {
    Conn *nsq.Consumer
}

func NewNsqEvent(strArr [2]string) {
    nsqChan <- strArr
}

func NsqChanProduce() {
	for {
		select {
		case strArr := <-nsqChan:
            go nsqHttpServe.Produce(strArr[0], strArr[1])
		case <-interrupt:
            close(nsqChan)
            nsqHttpServe.Close()
            return //退出
		}
	}
}

//给http服务设定一个nsq连接服务
func HttpNsq() *nsqServer {
    if nsqHttpServe == nil {
        nsqHttpServe = NewProducer()
    }
    if nsqHttpServe.Conn == nil {
        nsqHttpServe = NewProducer()
    }
    return nsqHttpServe
}

func NewProducer () *nsqServer {
    return &nsqServer { Conn: pubConn() }
}

func NewComsumer() *nsqClient {
    return &nsqClient { Conn: subConn() }
}

func pubConn() *nsq.Producer {
    p, err := nsq.NewProducer(nsqConf["nsqServer"], nsq.NewConfig())
    if err != nil {
        panic(err)
    }
    return p
}

func subConn() *nsq.Consumer {
    s, err := nsq.NewConsumer(GetTopic(), GetTopic(), nsq.NewConfig()) // 新建一个消费者
    if err != nil {
        panic(err)
    }
    //c.SetLogger(nil, 0)        //屏蔽系统日志
    s.AddHandler(&nsqClient{}) // 添加消费者接口

    //建立NSQLookupd连接
    if err := s.ConnectToNSQLookupd(nsqConf["nsqClient"]); err != nil {
        panic(err)
    }
    return s
}

//主题
func GetTopic() string {
    return nsqTopic
}


// nsq发布消息
func (server *nsqServer) Produce(msgBody string, topic string) error {
    if server.Conn == nil {
        server.Conn = pubConn()
    }
    if err := server.Conn.Publish(topic, []byte(msgBody)); err != nil {
        panic(err)
    }
    return nil
}

//关闭订阅
func (server *nsqServer) Close() {
    server.Close()
}

//nsq处理消息
func (*nsqClient) HandleMessage(msg *nsq.Message) error {
    fmt.Println(string(msg.Body))
    return nil
}
