package okeys

import(
    "fmt"
    "strings"
)

var configRdKeys = map[string]string{
    //redis user key
    "FireBaseList":         "FIREBASELIST",
    "UserSlotLock":         "USERSLOTLOCK",
    "UserAttr":             "NEW_USER_ATTR",
    "UserBuildLevel":       "USERBUILDLEVEL",
    "UserToken":            "USERTOKEN",
    "UserInfo":             "POKDENGHALL_T_USERINFO",
    "SpeedUpSpins":         "SPEEDUPSPINS",
    "UserBasicsStatistics": "NEW_USER_BASICSSTATISTICS",
    "UserAchieve":          "USERACHIEVE",
    "VipExperience":        "VIPEXPERIENCE",
    "SignInUserGroupId":    "SIGNINUSERGROUPID",
    "VersionGiftLog":       "VERSIONGIFTLOG",
    "Userfriends":          "USERFRIENDS",
    "UserFirstPayTime":     "USERFIRSTPAYTIME",
    "UserLastPayTime":      "USERLASTPAYTIME",
    "UserPayTimes":         "USERPAYTIMES2",
    "AdjustDeviceId":       "ADJUSTDEVICEID",

    //统计
    "UserAdjustGroup":      "USERADJUSTGROUP",
    "UserTotalPayNum":      "USERTOTALPAYNUM",
    "Report":               "REPORT",
    "NetworkReport":        "NETWORKREPORT",
    "LoginEventSta":        "LOGINEVENTSTA",
    "GiftEventSta":         "GIFTEVENTSTA",
    "ShareEventSta":        "SHAREEVENTSTA",
    "ActivityClickSta":     "ACTIVITYCLICKSTA",
    "FriendRecallSta":      "FRIENDRECALLSTA",
    "NoviceStepsSta":       "NOVICESTEPSSTATISTICS",
    "PayReport":            "PAYREPORT",
    "BuryingPointLog":      "BURYINGPOINTLOG",
    "InviteEventSta":       "INVITEEVENTSTA",
    "UserBindActRid":       "ACT_USER_BIND_RID",
    "CurForeVersion":       "CURFOREVERSION",

    //redis全局key
    "PlayParticipate":      "PARTIME",
    "PlayParticipateNum":   "PARNUM",
    "Landing":              "LANDING",
    "AssetsLog":            "ASSETS_LOG",
    "UpLimitConfig":        "UPLIMITCONFIG",
    "VipLvConfig":          "VIPLVCONFIG",
    "VipTurnTable":         "vipturntable",
    "Funnel":               "FUNNEL",
    "StaticConfig":         "STATICCONFIG",
    "GetVersionCount":      "GETVERSIONCOUNT",
    "StaticMd5Config":      "STATICMD5CONFIG",
    "LangStaticConfig":     "LANGSTATICCONFIG",
    "GameUpdateHotFix":     "GAMEUPDATEHOTFIX",
}


/**
* @Author Owen
* @Description 回归配置
* @Date 11:32 2021/1/18
* @原php方法
**/
func RecallConfig() string {
    return "RECALLCONFIG"
}

/**
* @Author Owen
* @Description 矿工小游戏配置
* @Date 11:32 2021/1/18
* @原php方法
**/
func SignInProgressConfig(sectionId int64) string {
    if sectionId == 0 {
        return "SIGNINPROGRESSCONFIG:2"
    }
    return "SIGNINPROGRESSCONFIG:2-" + fmt.Sprintf("%d", sectionId)
}

/**
* @Author Owen
* @Description 矿工小游戏配置
* @Date 11:32 2021/1/18
* @原php方法
**/
func MiningGameConfig() string {
    return "MININGGAMECONFIG-2"
}
/**
* @Author Owen
* @Description 建筑大师配置
* @Date 11:32 2021/1/18
* @原php方法
**/
func BuildMasterConfig() string {
    return "BUILDMASTERCONFIG"
}

/**
* @Author Owen
* @Description
* @Date 17:46 2021/1/15
* @原php方法
**/
func StealAttackConfig() string {
    return "STEALATTACKCONFIG:2"
}

/**
* @Author Owen
* @Description
* @Date 10:26 2021/1/15
* @原php方法
**/
func SysCompensateConfig() string {
    return "SYSCOMPENSATECONFIG"
}

/**
* @Author Owen
* @Description 分享配置
* @Date 19:25 2021/1/14
* @原php方法
**/
func ShareConfig() string {
    return "SHARECONFIG:NEW"
}

/**
* @Author Owen
* @Description 宝箱配置
* @Date 20:17 2021/1/13
**/
func ChestConfig(id int64) string {
    return "CHESTCONFIG:" + fmt.Sprintf("%d", id)
}

/**
* @Author Owen
* @Description 系统配置
* @Date 15:42 2021/1/13
**/
func GoodsCoin(level string , coins string) string{
    return "GOODSCOIN:" + level + "-" + coins
}

/**
* @Author Owen
* @Description 系统配置
* @Date 15:42 2021/1/13
**/
func SystemConfig() string{
    return "SYSTEMCONFIG"
}

/**
* @Author Owen
* @Description
* @Date 16:02 2021/1/11
**/
func UserGroupConfig() string {
    return "USERGROUPCONFIG:2"
}


/**
* @Author Owen
* @Description 用户动态数据
* @Date 12:30 2021/1/11
**/
func UserDynamicsData(uid int64 ) string {
    return "UserDynamicsData:" + fmt.Sprintf("%d", uid)
}

/**
* @Author Owen
* @Description 用户版本奖励记录
* @Date 18:26 2021/1/8
**/
func VersionGiftLog(uid int64 ,version string) string {
    return "VERSIONGIFTLOG:" + fmt.Sprintf("%d", uid) + "-" + version
}

func StaticConfig() string {
    return SplicingKeys("StaticConfig", []string{})
}

func GetVersionCount() string {
    return SplicingKeys("GetVersionCount", []string{})
}

func StaticMd5Config() string {
    return SplicingKeys("StaticMd5Config", []string{})
}

func LangStaticConfig() string {
    return SplicingKeys("LangStaticConfig", []string{})
}

func GameUpdateHotFix(sid int64, version string) string {
    version = strings.Replace(version, ".", "", -1)
    return SplicingKeys("GameUpdateHotFix", []string{fmt.Sprintf("%d", sid) + version})
}

/**
 * 玩家好友数据
 */
func Userfriends(uid int64, flag int64) string {
    return SplicingKeys("Userfriends", []string{fmt.Sprintf("%d", uid)+"-"+fmt.Sprintf("%d", flag)})
}

/**
 * 玩家首次支付时间
 */
func UserFirstPayTime(uid int64) string {
    return SplicingKeys("UserFirstPayTime", []string{fmt.Sprintf("%d", uid)})
}
/**
 * 玩家上次支付时间
 */
func UserLastPayTime(uid int64) string {
    return SplicingKeys("UserLastPayTime", []string{fmt.Sprintf("%d", uid)})
}

func UserPayTimes(uid int64) string {
    return SplicingKeys("UserPayTimes", []string{fmt.Sprintf("%d", uid)})
}

func CurForeVersion(sid int64) string {
    return SplicingKeys("CurForeVersion", []string{fmt.Sprintf("%d", sid)})
}

/**
* @Author Owen
* @Description 用户签到分组ID
* @Date 12:18 2021/1/8
**/
func SignInUserGroupId(uid int64) string {
    return SplicingKeys("SignInUserGroupId", []string{fmt.Sprintf("%d", uid)})
}

func UserBuildLevel(uid int64) string {
    return SplicingKeys("UserBuildLevel", []string{fmt.Sprintf("%d", uid)})
}

func UserInfo(uid int64) string {
    return SplicingKeys("UserInfo", []string{fmt.Sprintf("%d", uid)})
}

func UserAttr(uid int64) string {
    return SplicingKeys("UserAttr", []string{fmt.Sprintf("%d", uid)})
}

func UserToken(uid int64) string {
    return SplicingKeys("UserToken", []string{fmt.Sprintf("%d", uid)})
}

func SpeedUpSpins(uid int64) string {
    return SplicingKeys("SpeedUpSpins", []string{fmt.Sprintf("%d", uid)})
}

func UserBasicsStatistics(uid int64) string {
    return SplicingKeys("UserBasicsStatistics", []string{fmt.Sprintf("%d", uid)})
}

//成就
func UserAchieve(uid int64) string {
    return SplicingKeys("UserAchieve", []string{fmt.Sprintf("%d", uid)})
}

func VipExperience(uid int64) string {
    return SplicingKeys("VipExperience", []string{fmt.Sprintf("%d", uid)})
}

func UserAdjustGroup(uid int64) string {
    return SplicingKeys("UserAdjustGroup", []string{fmt.Sprintf("%d", uid)})
}

func UserTotalPayNum(uid int64) string {
    return SplicingKeys("UserTotalPayNum", []string{fmt.Sprintf("%d", uid)})
}

func Report(eventId int64, sid int64) string {
    if sid == 0 {
        return SplicingKeys("Report", []string{fmt.Sprintf("%d", eventId)})
    }
    return SplicingKeys("Report", []string{fmt.Sprintf("%d", eventId)+"-"+fmt.Sprintf("%d", sid)})
}

func NetworkReport(sid int64) string {
    return SplicingKeys("NetworkReport", []string{fmt.Sprintf("%d", sid)})
}

func InviteEventSta(sid int64, flag int64) string {
    return SplicingKeys("InviteEventSta", []string{fmt.Sprintf("%d", sid)+"-"+fmt.Sprintf("%d", flag)})
}

func UserBindActRid(uid int64, aid int64) string {
    return SplicingKeys("UserBindActRid", []string{fmt.Sprintf("%d", uid)+"-"+fmt.Sprintf("%d", aid)})
}

//玩家uid对应设备id
func AdjustDeviceId(uid int64) string {
    return SplicingKeys("AdjustDeviceId", []string{fmt.Sprintf("%d", uid)})
}

func NetworkReportSid(eventId int64, sid int64) string {
    return SplicingKeys("NetworkReport", []string{fmt.Sprintf("%d", eventId)+"-"+fmt.Sprintf("%d", sid)})
}

func LoginEventSta(sid int64) string {
    return SplicingKeys("LoginEventSta", []string{fmt.Sprintf("%d", sid)})
}

func GiftEventSta(sid int64, flag int64) string {
    return SplicingKeys("GiftEventSta", []string{fmt.Sprintf("%d", sid)+"-"+fmt.Sprintf("%d", flag)})
}

func ShareEventSta(sid int64, flag int64, eventId int64) string {
    return SplicingKeys("ShareEventSta", []string{fmt.Sprintf("%d", sid)+"-"+fmt.Sprintf("%d", flag)+"-"+fmt.Sprintf("%d", eventId)})
}

func ActivityClickSta() string {
    return SplicingKeys("ActivityClickSta", []string{})
}

func FriendRecallSta(flag int64) string {
    return SplicingKeys("FriendRecallSta", []string{fmt.Sprintf("%d", flag)})
}

func NoviceStepsSta(flag int64) string {
    if flag == 0 {
        return SplicingKeys("NoviceStepsSta", []string{})
    }
    return SplicingKeys("NoviceStepsSta", []string{"fb"})
}

func PayReport(sid int64, eventId int64) string {
    if eventId == 10008 {
        return SplicingKeys("PayReport", []string{fmt.Sprintf("%d", sid)})
    }
    return SplicingKeys("PayReport", []string{fmt.Sprintf("%d", sid)+"-"+fmt.Sprintf("%d", eventId)})
}

func Funnel() string {
    return SplicingKeys("Funnel", []string{})
}

func BuryingPointLog (day int64) string {
    return SplicingKeys("BuryingPointLog", []string{fmt.Sprintf("%d", day)})
}

//vip配置信息
func VipLvConfig(keys ... string) string {
    if len(keys) == 0 {
        return CommonKeys("VipLvConfig")
    }
    return SplicingKeys("VipLvConfig", []string{keys[0]})
}

//每日转转盘
func VipTurnTable(keys ... string) string {
    if len(keys) == 0 {
        return CommonKeys("VipTurnTable")
    }
    return SplicingKeys("VipTurnTable", []string{keys[0]})
}

//小游戏参与率时长
func PlayParticipate(day string, playType string) string {
    return SplicingKeys("PlayParticipate", []string{day, playType})
}

//小游戏参与率次数
func PlayParticipateNum(day string, playType string) string {
    return SplicingKeys("PlayParticipateNum", []string{day, playType})
}

//世界
func Landing(key string) string {
    return SplicingKeys("Landing", []string{key})
}

//上限配置
func UpLimitConfig() string {
    return CommonKeys("UpLimitConfig")
}

//流水日志缓存
func AssetsLog(key string) string {
    return SplicingKeys("AssetsLog", []string{key})
}

func CommonKeys(key string) string {
    return configRdKeys[key]
}

func TaEvent(key string) string {
    return "SS_EVENT:"+key
}

//冒号key
func SplicingKeys(key string, params []string) string {
    return SplicingFlagKeys(key, params, ":")
}

//横杠
func UserHorKeys(key string, params []string, flag string) string {
    return SplicingFlagKeys(key, params, "-")
}

func SplicingFlagKeys(key string, params []string, flag string) string {
    if _, ok := configRdKeys[key]; !ok {
        return ""
    }
    str := configRdKeys[key]
    for _, v := range params {
        str = fmt.Sprintf("%s%s%s", str, flag, v)
    }
    return str
}
func SSEventsList()  string{
    return "SS_EVENTS_LIST";
}