package statistics

import (
    "strconv"
    //"strings"
    "time"
    "Crazy_Push/models/tables"
    "Crazy_Push/models/log"
    "Crazy_Push/models/dblogic"
    "Crazy_Push/models/okeys"
)

const (
    BURYPOINTLOGPERNUM = 800 //每次从埋点日志中取出的数量
)

//玩家埋点日志入数据库
type BuryPointLogs struct {
    RdsFlag string
}

//玩家埋点日志日志入库
func NewBuryPointLogs() *BuryPointLogs {
    return &BuryPointLogs{
        RdsFlag: "BuryPointLogs",
    }
}

//埋点当前记录redis取出
func (buryPointLogs *BuryPointLogs) AsyncBuryPointLogs() {
    var num int64
    for {
        day := GetYmdDay()
        dayInt64, _ := strconv.ParseInt(day, 10, 64)
        key := okeys.BuryingPointLog(dayInt64)
        strArr, err := dblogic.R("STATISTICS", buryPointLogs.RdsFlag).LRange(key, -BURYPOINTLOGPERNUM, -1)
        if err != nil {
            log.LogError("async_burypoint_log", "get data fail from redis", key)
            continue
        }
        if len(strArr) == 0 {
            time.Sleep(time.Second * 10)
            continue
        }
        if len(strArr) < int(BURYPOINTLOGPERNUM) {
            num = int64(len(strArr))
        } else {
            num = BURYPOINTLOGPERNUM
        }
        dblogic.R("STATISTICS", buryPointLogs.RdsFlag).LTrim(key, 0, -num-1) //从队列中删除
        buryPointLogs.strToDb(strArr) //批量入库
        time.Sleep(time.Second * 5) //实时性不要求那么高
    }
}

//流水记录入库
func (buryPointLogs *BuryPointLogs) strToDb(strArr []string) bool {
    tb      := &tables.TBuryingPoint{}
    inserts := []tables.TBuryingPoint{}
    for _, val := range(strArr) {
        err := json.Unmarshal([]byte(val), &tb)
        if err != nil {
            log.LogError("async_burypoint_log", "json unmarshal log str error", err, val)
            continue
        }
        inserts = append(inserts, *tb)
    }

    if len(inserts) < 1 { //没有需要插入的数据
        return true
    }
    err := dblogic.M("STATISTICS").Create(&inserts).Error
    if err != nil {
        log.LogError("async_burypoint_log", "multi insert int bury point error", err)
        return false
    }
    return true
}
