package statistics

import (
    "strings"
    "strconv"

    "Crazy_Push/models/log"
    "Crazy_Push/models/tables"
    "Crazy_Push/models/dblogic"
    "Crazy_Push/models/okeys"
)

const (
    FLAGFRIENDSALL  = "all"
    FLAGFRIENDSGAME = "game"
    FLAGFRIENDFB    = "fb"
)

type Friend struct { }

func NewFirend() *Friend {
    return &Friend{}
}

//好友列表
func (friend *Friend) GetUserAllFriend(uid string, flag string) []int64 {
    uidInt64, _  := strconv.ParseInt(uid, 10, 64)
    flagInt64, _ := strconv.ParseInt(flag, 10, 64)
    tmp, err     := dblogic.R("games").Get(okeys.Userfriends(uidInt64, flagInt64))
    friends := []int64{}
    if err != nil {
        log.LogError("static_friend", "get user friends error", uid, flag, err, tmp)
        tmp = ""
    }
    tmpUids := []string{}
    if tmp != "" {
        err := json.Unmarshal([]byte(tmp), &tmpUids)
        if err != nil {
            log.LogError("static_friend", "json unmarshal friends error", uid, err, tmp)
        }
    } else {
        friendsDb := friend.GetUserFriends(uid)
        if friendsDb == nil {
            return friends
        }
        if flag == FLAGFRIENDSGAME && friendsDb.GameList != "" {
            tmpUids = strings.Split(friendsDb.GameList, ",")
        }
        if flag == FLAGFRIENDFB && friendsDb.GameList != "" {
            tmpUids = strings.Split(friendsDb.GameList, ",")
        }
        if flag == FLAGFRIENDSALL {
            if friendsDb.Poker != "" {
                tmpUids = append(tmpUids, strings.Split(friendsDb.Poker, ",")...)
            }
            if friendsDb.GameList != "" {
                tmpUids = append(tmpUids, strings.Split(friendsDb.GameList, ",")...)
            }
        }
    }
    if len(tmpUids) < 1 {
        return friends
    }
    for _, v := range tmpUids {
        f, err := strconv.ParseInt(v, 10, 64)
        if err != nil {
            log.LogError("static_friend", "strconv string to int64 error", v, err)
            continue
        }
        friends = append(friends, f)
    }
    return friends
}

//从mysql获取玩家好友数据
func (friend *Friend) GetUserFriends(uid string) *tables.TUserfriends {
    tb := &tables.TUserfriends{}
    err := dblogic.M("USER").Where("uid = ?", uid).First(&tb).Error
    if err != nil {
        return nil
    }
    return tb
}
