package statistics

import (
    //"fmt"
    "time"
    "strconv"

    "Crazy_Push/models/log"
    "Crazy_Push/models/dblogic"
    "Crazy_Push/models/okeys"
    "Crazy_Push/core/function"
)

const (
    PLAYCOINDOZERTYPE = 1 //推金币
    PLAYMININGTYPE    = 2 //黄金矿工
    PLAYTURNTABLETYPE = 3 //大转盘
    PLAYLUCKYDRAWTYPE = 4 //夺宝活动
    PLAYTREASURE      = 5 //宝藏活动
)

//小游戏统计
type PlayReports struct {
    //PlayTime int64,
    //PlayType int64,
}

func NewPlayReports() *PlayReports {
    return &PlayReports{}
}

func (plr *PlayReports) GetTypes() map[int64]string {
    return map[int64]string {
        PLAYCOINDOZERTYPE: "coindozer",
        PLAYMININGTYPE:    "mining",
        PLAYTURNTABLETYPE: "turntable",
        PLAYLUCKYDRAWTYPE: "luckydraw", //夺宝活动
        PLAYTREASURE:      "treasure",
    }
}

func (plr *PlayReports) CheckType(PlayType int64) bool {
    types := plr.GetTypes()
    if _, ok := types[PlayType]; !ok {
        return false
    }
    return true
}

//玩家小游戏时长统计
func (plr *PlayReports)SavePlayStatistic(ret map[string]interface{}) bool {
    uid := strconv.FormatInt(ret["uid"].(int64), 10)
    playType := strconv.FormatInt(ret["play_type"].(int64), 10)
    day := function.Date("20060102", time.Now().Unix())
    keyTime := okeys.PlayParticipate(day, playType)
    keyNum := okeys.PlayParticipateNum(day, playType)
    _, err := dblogic.R("Statistics").HIncrBy(keyTime, uid, ret["play_time"].(int64))
    dblogic.R("Statistics").HIncrBy(keyNum, uid, 1)
    if err != nil {
        log.LogError("statistic_play", "redis小游戏时长统计失败", uid, err)
        return false
    }
    ttl, _ := dblogic.R("Statistics").TTL(keyTime)
    if ttl == time.Second * -1 { //保留7天
        dblogic.R("Statistics").Expire(keyTime, (7*24*3600*time.Second))
        dblogic.R("Statistics").Expire(keyNum, (7*24*3600*time.Second))
    }
    return true
}
