<?php
$tmp = file_get_contents('./table.txt');

$prefix = 'ly_';
$arr = explode("\n", $tmp);
if(empty($arr)){
    exit;
}

array_pop($arr);
array_pop($arr);

$first = array_shift($arr);
$table = getName($first, true);

if(empty($table)){
    exit;
}
$name = $table;
$table = getImplodeName($name, $prefix);

$str = "package tables\n\n";
//$str .= "import (\n    \"github.com/jinzhu/gorm\"\n)\n\n";
$str .= "type {$table} struct {\n";

foreach($arr as $v) {
    $t = getName($v);
    if(empty($t)){
        continue;
    }
    $column = getImplodeName($t);
    if(empty($column)){
        continue;
    }
    $v = str_replace('`'.$t.'` ', '', $v);
    $index = strpos($v, ' COMMENT');
    if($index !== false){
        $v = substr($v, 0, $index);
    }
    $unsigned = strpos($v, 'unsigned');
    //$v = preg_replace(['/NOT\ NULL/', '/not\ null/'], ['NOTNULL', 'NOTNULL'], $v);
    $v = strtolower(trim($v));
    $v = str_replace('not null', 'notnull', $v);
    $v = preg_replace(['/,/', '/ /', '/unsigned/'], ['', ':', ''], $v);
    $v = str_replace('::', ':', $v);
    $type = getDataType($v);
    if($type == 'int64'){
        //$v = str_replace("default:'0'", 'default:0', $v);
        $v = str_replace("'", '', $v);
    }
    $list = explode(':', $v);
    array_unshift($list, 'type');
    $vv = '';
    foreach($list as $k => $v2){
        if($v2 == 'notnull'){
            $v2 = 'not null';
        }
        if($k % 2 == 0){
            $vv .= $v2;
        }else{
            $vv .= ':'.$v2.';';
        }
    }
    $vv = rtrim($vv, ';');
    if($unsigned !== false){
        $vv .= ';unsigned';
    }
    $vv = str_replace('default;', 'default:', $vv);
    $vv = str_replace('not null:', 'not null;', $vv);
    $vv .= ';column:'.$t;
    //$str .= "    {$column} {$type} `gorm:\"type:{$v}\" json:\"".$t."\"`\n";
    $str .= "    {$column} {$type} `gorm:\"{$vv}\" json:\"".$t."\"`\n";
}
$str .= "}\n\nfunc({$table}) TableName() string {\n";
$str .= "    return \"{$name}\"\n}";
file_put_contents(strtolower($table).'.go', $str);

function getName($str = '', $table = false) {
    $str = trim($str);
    $start = strpos($str, '`');
    $end = strrpos($str, '`');
    if($start === false || $end === false){
        return '';
    }
    if($start !== 0 && !$table){
        return '';
    }
    return substr($str, $start + 1, $end - $start - 1);
}

function getImplodeName($str = '', $prefix = '') {
    $str = $prefix ? ltrim($str, $prefix) : $str;
    $arr = explode('_', $str);
    $arr = array_map(function($v){
        return ucfirst($v);
    }, $arr);
    return implode($arr, '');
}

function getDataType($v) {
    if(strpos($v, 'char') !== false){
        return 'string';
    }elseif(strpos($v, 'bigint') !== false){
        return 'string';
    }elseif(strpos($v, 'int') !== false){
        return 'int64';
    }elseif(strpos($v, 'bool') !== false){
        return 'bool';
    }elseif(strpos($v, 'date') !== false){
        return 'time.Time';
    }elseif(strpos($v, 'numeric') !== false){
        return 'int64';
    }else{
        return 'string';
    }
}
