package tables

import(
    "strings"

    "Crazy_Push/models/log"
)

var (
    redisConf = map[string]string {
        "Games":      "main.games",
        "Statistics": "main.statistics",
        "Campaign":   "main.campaign",
    }
)

//返回数据库配置
func GetRdConf(keys ...string) string {
    name := ""
    if len(keys) == 0 {
        name = "Games"
    }else{
        name = keys[0]
    }

    if _, ok := redisConf[name]; ok {
        return redisConf[name]
    }
    str := strings.ToLower(name)
    switch str {
        case "games":
            name = "Games"
        case "statistics":
            name = "Statistics"
        case "campaign":
            name = "Campaign"
        default: //默认获取游戏实例
            log.LogInst("redis").Error("获取redis实例参数错误:", keys)
            name = "Games"
    }
    return redisConf[name]
}
