package tables

type TFacebookAds struct {
    AccountId string `gorm:"type:varchar(30);not null;column:account_id" json:"account_id"`
    DateStart string `gorm:"type:varchar(20);default:null;column:date_start" json:"date_start"`
    DateStop string `gorm:"type:varchar(20);default:null;column:date_stop" json:"date_stop"`
    Country string `gorm:"type:varchar(20);default:null;column:country" json:"country"`
    AdId string `gorm:"type:varchar(30);default:null;column:ad_id" json:"ad_id"`
    AdName string `gorm:"type:varchar(255);default:null;column:ad_name" json:"ad_name"`
    AdsetId string `gorm:"type:varchar(30);default:null;column:adset_id" json:"adset_id"`
    AdsetName string `gorm:"type:varchar(255);default:null;column:adset_name" json:"adset_name"`
    CampaignId string `gorm:"type:varchar(30);default:null;column:campaign_id" json:"campaign_id"`
    CampaignName string `gorm:"type:varchar(255);default:null;column:campaign_name" json:"campaign_name"`
    Clicks int64 `gorm:"type:int(11);default:null;column:clicks" json:"clicks"`
    Impressions int64 `gorm:"type:int(11);default:null;column:impressions" json:"impressions"`
    InlineLinkClicks int64 `gorm:"type:int(11);default:null;column:inline_link_clicks" json:"inline_link_clicks"`
    Reach int64 `gorm:"type:int(11);default:null;column:reach" json:"reach"`
    Spend float64 `gorm:"type:varchar(20);default:null;column:spend" json:"spend"`
    Cpc string `gorm:"type:varchar(20);default:null;column:cpc" json:"cpc"`
    AttributionSetting string `gorm:"type:varchar(50);default:null;column:attribution_setting" json:"attribution_setting"`
    LinkClick int64 `gorm:"type:int(11);default:null;column:link_click" json:"link_click"`
    AppInstall int64 `gorm:"type:int(11);default:0;column:app_install" json:"app_install"`
    MobileAppInstall int64 `gorm:"type:int(11);default:null;column:mobile_app_install" json:"mobile_app_install"`
    ThreeSecVideoView int64 `gorm:"type:int(11);default:null;column:three_sec_video_view" json:"three_sec_video_view"`
    VideoPlayActions int64 `gorm:"type:int(11);default:null;column:video_play_actions" json:"video_play_actions"`
    VideoAvgTimeWatchedActions int64 `gorm:"type:int(11);default:null;column:video_avg_time_watched_actions" json:"video_avg_time_watched_actions"`
    VideoP25WatchedActions int64 `gorm:"type:int(11);default:null;column:video_p25_watched_actions" json:"video_p25_watched_actions"`
    VideoP50WatchedActions int64 `gorm:"type:int(11);default:null;column:video_p50_watched_actions" json:"video_p50_watched_actions"`
    VideoP75WatchedActions int64 `gorm:"type:int(11);default:null;column:video_p75_watched_actions" json:"video_p75_watched_actions"`
    VideoP95WatchedActions int64 `gorm:"type:int(11);default:null;column:video_p95_watched_actions" json:"video_p95_watched_actions"`
    VideoP100WatchedActions int64 `gorm:"type:int(11);default:null;column:video_p100_watched_actions" json:"video_p100_watched_actions"`
    ImpressionDevice string `gorm:"type:varchar(255);default:null;column:impression_device" json:"impression_device"`
    Video15SecWatchedActions int64 `gorm:"type:int(11);default:0;column:video_15_sec_watched_actions" json:"video_15_sec_watched_actions"`
}

func(TFacebookAds) TableName() string {
    return "t_facebook_ads"
}
