package tables

type TMiningGameConfig struct {
	Lv int64 `gorm:"type:int(11);primary_key;default:0;column:lv" json:"lv"` 
	MineralData string `gorm:"type:text;not null;column:mineralData" json:"mineralData"` 
	HookUpSpeed string `gorm:"type:varchar(250);not null;column:hookUpSpeed" json:"hookUpSpeed"` 
	HookDownSpeed float64 `gorm:"type:float(11,2);not null;column:hookDownSpeed" json:"hookDownSpeed"` 
	Duration int64 `gorm:"type:int(11);not null;column:duration" json:"duration"` 
	Target int64 `gorm:"type:int(11);not null;default:0;column:target" json:"target"` 
	HookSpinSpeed float64 `gorm:"type:float(11,2);not null;default:1.30;column:hookSpinSpeed" json:"hookSpinSpeed"` 
	UpLevelDiamond int64 `gorm:"type:int(11);not null;default:0;column:upLevelDiamond" json:"upLevelDiamond"` 
	DiamondCoins int64 `gorm:"type:int(11);not null;default:0;column:diamondCoins" json:"diamondCoins"` 
	ResurrectionDiamond int64 `gorm:"type:int(11);not null;default:0;column:resurrectionDiamond" json:"resurrectionDiamond"` 
}

func (TMiningGameConfig) TableName() string {
	return "t_mining_game_config2"
}

type TMiningGameConfigRedis struct {
	*TMiningGameConfig
	MineralData []*MineralData `json:"mineralData"`
	HookUpSpeed []*HookUpSpeed `json:"hookUpSpeed"`
}

type MineralData struct {
	Id int64 `json:"id"`
	Floor int64 `json:"floor"`
	Num int64 `json:"num"`
}

type HookUpSpeed struct {
	Id int64 `json:"id"`
	Floor int64 `json:"floor"`
	Num int64 `json:"num"`
}
