package tables

type TUserGroup struct {
	Id int64 `gorm:"type:int(11) unsigned;primary_key;column:id" json:"id"`
	GroupId int64 `gorm:"type:int(11);not null;column:groupId" json:"groupId"`
	Name string `gorm:"type:varchar(50);not null;column:name" json:"name"`
	Remark string `gorm:"type:varchar(500);not null;column:remark" json:"remark"`
	Update int64 `gorm:"type:tinyint(4);not null;default:0;column:update" json:"update"`
	AdTotal int64 `gorm:"type:int(11);not null;default:10;column:adTotal" json:"adTotal"`
	Condition string `gorm:"type:text;not null;column:condition" json:"condition"`
	Sort int64 `gorm:"type:int(11);not null;default:0;column:sort" json:"sort"`
	SignIn string `gorm:"type:varchar(4096);not null;column:signIn" json:"signIn"`
}

func (TUserGroup) TableName() string {
	return "t_user_group2"
}

type TUserGroupRedis struct {
	* TUserGroup
	Condition []map[string]interface{} `json:"condition"`
	SignIn map[int64]*SignInRewardConfig `json:"signIn"`
}

type SignInRewardConfig struct {
	Id int64 `json:"id"`
	Coins map[string]string `json:"coins"`
	Spins int64 `json:"spins"`
	Props []*Props `json:"props"`
}

type SignInRewardConfigClient struct {
	Id int64 `json:"id"`
	Props []*Props `json:"props"`
}

type Props struct {
	PropsId int64 `json:"propsId"`
	Num int64 `json:"num"`
	Value interface{} `json:"value,omitempty" `
}
