package http

import (
	"net"
	"net/http"
	"time"
)

/*
   Create Time：2021/2/23 10:12
   Author：王勇攀
*/
/*
   Description:
*/

const (
	MaxIdleConns        int = 10
	MaxIdleConnsPerHost int = 5
	IdleConnTimeout     int = 60
	KeepAlive           int = 86400
	DialTimeout         int = 5
	RequestTimeout      int = 3
)

//Long Connection
func CreateHTTPClient() *http.Client {
	client := &http.Client{
		Transport: &http.Transport{
			Proxy: nil,
			DialContext: (&net.Dialer{
				Timeout:   time.Duration(DialTimeout) * time.Second,
				KeepAlive: time.Duration(KeepAlive) * time.Second,
			}).DialContext,
			MaxIdleConns:        MaxIdleConns,
			MaxIdleConnsPerHost: MaxIdleConnsPerHost,
			IdleConnTimeout:     time.Duration(IdleConnTimeout) * time.Second,
		},
		CheckRedirect: nil,
		Jar:           nil,
		Timeout:       time.Duration(RequestTimeout) * time.Second,
	}
	return client
}

func Close(client *http.Client) {
	if client != nil {
		client.CloseIdleConnections()
	}
}
