package json

import (
	"strconv"
	"unsafe"

	"Crazy_Push/models/utils/er"

	j "github.com/json-iterator/go"
	"github.com/json-iterator/go/extra"
)
var json = j.ConfigCompatibleWithStandardLibrary

/*
   Create Time：2021/1/19 15:53
   Author：王勇攀
*/
/*
   Description:
*/

func MarshalToString(v interface{}) string {
	r, err := j.MarshalToString(v)
	er.IsErr(err)
	return r
}

func UnmarshalFromString(s string, v interface{}) {
	er.IsErr(j.UnmarshalFromString(s, v))
}

func UnMarshal(d []byte, v interface{}) {
	er.IsErr(j.Unmarshal(d, v))
}

func Marshal(v interface{}) []byte {
	res, err := j.Marshal(v)
	er.IsErr(err)
	return res
}

func MarshalToStringWithErr(v interface{}) (string, error) {
	r, err := j.MarshalToString(v)
	if err != nil {
		return "", err
	}
	return r, nil
}

func UnmarshalFromStringWithErr(s string, v interface{}) error {
	return j.UnmarshalFromString(s, v)
}

func UnmarshalWithErr(d []byte, v interface{}) error {
	return j.Unmarshal(d, v)
}

func MarshalWithErr(v interface{}) ([]byte, error) {
	res, err := j.Marshal(v)
	if err != nil {
		return nil, err
	}
	return res, nil
}

func RegStringBoolExtension() {
	j.RegisterTypeDecoderFunc("bool", func(ptr unsafe.Pointer, iter *j.Iterator) {
		//false true
		a := iter.ReadBool()
		if iter.Error == nil {
			*((*bool)(ptr)) = bool(a)
			return
		}
		iter.Error = nil

		//"1", "t", "T", "true", "TRUE", "True","0", "f", "F", "false", "FALSE", "False"
		b, err := strconv.ParseBool(iter.ReadString())
		if err == nil {
			*((*bool)(ptr)) = bool(b)
			return
		}
		//"NULL","null",""
		c := iter.ReadString()
		if iter.Error == nil {
			switch c {
			case "", "NUll", "null":
				*((*bool)(ptr)) = false
			}
		}
		iter.Error = nil
		//0,1
		d := iter.ReadInt()
		if iter.Error == nil {
			if d == 1 {
				*((*bool)(ptr)) = true
			} else {
				*((*bool)(ptr)) = false
			}
		}
	})
}

func init() {
	extra.RegisterFuzzyDecoders()
	RegStringBoolExtension()
}
