// Package log is
package log

import (
	"go.uber.org/zap"
	"go.uber.org/zap/zapcore"
)

var (
	// Deprecated
	// use TkLogInfo  TKLogError TkLogSystemInfo TkLogSystemError
	ConsoleLogger *zap.Logger
	// Deprecated
	// use TkLogInfo  TKLogError TkLogSystemInfo TkLogSystemError
	SugarLogger *zap.SugaredLogger
)

func init() {
	config := zap.NewDevelopmentConfig()
	config.EncoderConfig.EncodeTime = zapcore.TimeEncoderOfLayout("2006-01-02 15:04:05")
	ConsoleLogger, _ = config.Build(zap.AddStacktrace(zapcore.InfoLevel), zap.AddStacktrace(zapcore.ErrorLevel))
	SugarLogger = ConsoleLogger.Sugar()
}
