package utils

import (
	//"fmt"
	//"net"
	"net/http"
	"runtime/debug"
	"time"

	"Crazy_Push/models/log"
	"github.com/gin-gonic/gin"
)

//热重启
//var(
//    server *http.Server
//)
//
//func NewServer(r *gin.Engine) {
//    server = &http.Server {
//		Handler:           r,
//		Addr:              fmt.Sprintf("0.0.0.0:8089"),
//		IdleTimeout:       20 * time.Second, // tcp idle time
//		ReadHeaderTimeout: 10 * time.Second,
//		ReadTimeout:       10 * time.Second,
//		WriteTimeout:      15 * time.Second,
//	}
//}

//监听服务器
func Listenserver(r *gin.Engine, port string){
	r.Run(":"+port)
    //err := endless.ListenAndServe("0.0.0.0:"+port, r)
	//if err != nil {
	//	log.LogError("endless", err)
	//}
    //log.LogInfo("endless", "Server on 8089 stopped")
	//os.Exit(0)
}

//// 异常处理
func Recovery() gin.HandlerFunc {
	return func(c *gin.Context) {
		defer func() {
			if err := recover(); err != nil {
				//traceId := c.Writer.Header().Get("X-Request-Trace-Id")
				logField := map[string]interface{}{
					//"trace_id":    traceId, //唯一跟踪ID和用户名
					//"user":        c.Writer.Header().Get("X-Request-User"),
					"uri":         c.Request.URL.Path,
					"remote_addr": c.ClientIP(),
					"stack":       string(debug.Stack()), // 打印堆栈信息
                    "time":        time.Now().Format("2006-01-02 15:04:05"),
                    "content":     err,
				}

				c.Abort()
				log.LogError("panic", logField) // 输出panic 信息
				c.JSON(http.StatusBadRequest, gin.H{
                    "code": 500,
                    "msg":  "服务器异常",
                    "data": "[]",
                })
				return
			}
		}()
		c.Next()
	}
}
