package tracing

import (
	"context"
	"fmt"

	"github.com/asim/go-micro/plugins/wrapper/trace/opentracing/v3"
	opentracinggo "github.com/opentracing/opentracing-go"
)

func ContextWithTrace(serviceName string) context.Context {
	name := fmt.Sprintf("%s", serviceName)
	ctx, span, _ := opentracing.StartSpanFromContext(context.Background(), opentracinggo.GlobalTracer(), name)
	defer span.Finish()
	return ctx
}