package utils

import (
	"reflect"
	"strings"
)

func ChangeVersionLength(version string,length int64) string {
	versionArr := strings.Split(version, ".")
	var returnVersion []string
	for index,value := range versionArr{
		if int64(index)  < length {
			returnVersion = append(returnVersion,value)
		}
	}
	return strings.Join(returnVersion,".")
}

/**
* @Author Owen
* @Description 切片去空字符串
* @Date 15:28 2021/1/11
* @Param
* @return
**/
func ArrayFilter(a []string) (ret []string){
	s_len := len(a)
	for i:=0; i < s_len; i++{
		if len(a[i])==0 {
			continue
		}
		ret = append(ret, a[i])
	}
	return
}

/**
* @Author Owen
* @Description 判斷是否在切片内
* @Date 17:49 2021/1/11
**/
func InArray(need interface{}, needArr []interface{}) bool {
	for _,v := range needArr{
		if need == v{
			return true
		}
	}
	return false
}

func ArrayStringToInterFace(s []string) []interface{} {
	nd := make([]interface{}, len(s))
	for v := range s {
		nd = append(nd, v)
	}
	return nd
}

func ArrayKeys(d map[string]string) []string {
	nd := make([]string, len(d))
	for v := range d {
		if v != "" {
			nd = append(nd, v)
		}
	}
	return nd
}
func ArrayValues(d map[string]string) []string {
	nd := make([]string, len(d))
	for _, v := range d {
		if v != "" {
			nd = append(nd, v)
		}
	}
	return nd
}

func ArrayColumn(d map[int64]map[string]string, columnKeys string) []interface{} {
	var nd []interface{}
	for _, v := range d {
		for e, q := range v {
			if e == columnKeys {
				nd = append(nd,q)
			}
		}
	}
	return nd
}


func ArrayMin(arr []interface{}) interface{} {
	if len(arr) == 0 {
		return false
	}
	minimum := arr[0]
	for _, v := range arr {
		switch v.(type) {
		case int:
			if v := v.(int); v < minimum.(int) {
				minimum = v
			}
		case int64:
			if v := v.(int64); v < minimum.(int64) {
				minimum = v
			}
		case float64:
			if v := v.(float64); v < minimum.(float64) {
				minimum = v
			}
		case string:
			if v := v.(string); v < minimum.(string) {
				minimum = v
			}
		}
	}
	return minimum
}

func ArrayMax(arr []interface{}) interface{} {
	if len(arr) == 0 {
		return false
	}
	minimum := arr[0]
	for _, v := range arr {
		switch v.(type) {
		case int:
			if v := v.(int); v > minimum.(int) {
				minimum = v
			}
		case int64:
			if v := v.(int64); v > minimum.(int64) {
				minimum = v
			}
		case float64:
			if v := v.(float64); v > minimum.(float64) {
				minimum = v
			}
		case string:
			if v := v.(string); v > minimum.(string) {
				minimum = v
			}
		}
	}
	return minimum
}

func CopyStruct(src, dst interface{}) {
	sval := reflect.ValueOf(src).Elem()
	dval := reflect.ValueOf(dst).Elem()

	for i := 0; i < sval.NumField(); i++ {
		value := sval.Field(i)
		name := sval.Type().Field(i).Name

		dvalue := dval.FieldByName(name)
		if dvalue.IsValid() == false {
			continue
		}
		dvalue.Set(value) //这里默认共同成员的类型一样，否则这个地方可能导致 panic，需要简单修改一下。
	}
}
